#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK ChildProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("SetWindowLong3");

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
		  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=(WNDPROC)WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	WndClass.cbWndExtra=8;
	WndClass.hCursor=LoadCursor(NULL,IDC_CROSS);
	WndClass.lpfnWndProc=(WNDPROC)ChildProc;
	WndClass.lpszClassName="ChildCls";
	WndClass.hbrBackground=(HBRUSH)GetStockObject(LTGRAY_BRUSH);
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	int x,y;
	switch(iMessage) {
	case WM_CREATE:
		for (x=0;x<1000;x+=100)
			for (y=0;y<1000;y+=100) {
				CreateWindow("ChildCls",NULL,WS_CHILD | WS_VISIBLE,
				x,y,100,100,hWnd,(HMENU)NULL,g_hInst,NULL);
			}
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}

LRESULT CALLBACK ChildProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	int Shape;
	COLORREF Color;
	HBRUSH hBrush, OldBrush;

	switch(iMessage) {
	case WM_CREATE:
		SetWindowLong(hWnd, 0, 0);
		SetWindowLong(hWnd, 4, RGB(0,0,255));
		return 0;
	case WM_LBUTTONDOWN:
		Shape=GetWindowLong(hWnd,0);
		Shape++;
		if (Shape==3)
			Shape=0;
		SetWindowLong(hWnd,0,Shape);
		InvalidateRect(hWnd,NULL,TRUE);
		return 0;
	case WM_RBUTTONDOWN:
		Color=GetWindowLong(hWnd,4);
		if (Color == RGB(0,0,255)) {
			Color=RGB(255,0,0);
		} else {
			Color = Color << 8;
		}
		SetWindowLong(hWnd,4,Color);
		InvalidateRect(hWnd,NULL,TRUE);
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		Color=GetWindowLong(hWnd,4);
		Shape=GetWindowLong(hWnd,0);
		hBrush=CreateSolidBrush(Color);
		OldBrush=(HBRUSH)SelectObject(hdc,hBrush);
		switch (Shape) {
		case 0:
			Rectangle(hdc,0,0,100,100);
			break;
		case 1:
			RoundRect(hdc,0,0,100,100,40,40);
			break;
		case 2:
			Ellipse(hdc,0,0,100,100);
			break;
		}
		EndPaint(hWnd, &ps);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
